package com.ruoyi.manage.mapper;

import com.ruoyi.manage.domain.DialIndicatorLog;

import java.util.List;

/**
 * 计报警记录Mapper接口
 * 
 * @author boman
 * @date 2025-06-17
 */
public interface DialIndicatorLogMapper 
{
    /**
     * 查询计报警记录
     * 
     * @param logId 计报警记录主键
     * @return 计报警记录
     */
    public DialIndicatorLog selectDialIndicatorLogByLogId(Long logId);

    /**
     * 查询计报警记录列表
     * 
     * @param dialIndicatorLog 计报警记录
     * @return 计报警记录集合
     */
    public List<DialIndicatorLog> selectDialIndicatorLogList(DialIndicatorLog dialIndicatorLog);

    /**
     * 新增计报警记录
     * 
     * @param dialIndicatorLog 计报警记录
     * @return 结果
     */
    public int insertDialIndicatorLog(DialIndicatorLog dialIndicatorLog);

    /**
     * 修改计报警记录
     * 
     * @param dialIndicatorLog 计报警记录
     * @return 结果
     */
    public int updateDialIndicatorLog(DialIndicatorLog dialIndicatorLog);

    /**
     * 删除计报警记录
     * 
     * @param logId 计报警记录主键
     * @return 结果
     */
    public int deleteDialIndicatorLogByLogId(Long logId);

    /**
     * 批量删除计报警记录
     * 
     * @param logIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteDialIndicatorLogByLogIds(Long[] logIds);
}
